'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.replaceInTemplates = exports.runTasks = exports.getTasks = exports.getBuildSteps = undefined;

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _extends3 = require('babel-runtime/helpers/extends');

var _extends4 = _interopRequireDefault(_extends3);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _entries = require('babel-runtime/core-js/object/entries');

var _entries2 = _interopRequireDefault(_entries);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _glob = require('glob');

var _glob2 = _interopRequireDefault(_glob);

var _gulp = require('gulp');

var _gulp2 = _interopRequireDefault(_gulp);

var _gulpUtil = require('gulp-util');

var _gulpUtil2 = _interopRequireDefault(_gulpUtil);

var _gulpPlumber = require('gulp-plumber');

var _gulpPlumber2 = _interopRequireDefault(_gulpPlumber);

var _gulpTap = require('gulp-tap');

var _gulpTap2 = _interopRequireDefault(_gulpTap);

var _gulpFilter = require('gulp-filter');

var _gulpFilter2 = _interopRequireDefault(_gulpFilter);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _del = require('del');

var _del2 = _interopRequireDefault(_del);

var _yargs = require('yargs');

var _yargs2 = _interopRequireDefault(_yargs);

var _jsYaml = require('js-yaml');

var _jsYaml2 = _interopRequireDefault(_jsYaml);

var _index = require('./config/index.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// entry
exports.default = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5() {
  var startTime, _ret;

  return _regenerator2.default.wrap(function _callee5$(_context6) {
    while (1) {
      switch (_context6.prev = _context6.next) {
        case 0:
          startTime = new Date();

          _gulpUtil2.default.log(_gulpUtil2.default.colors.yellow('Loading gassetic.yml'));

          _context6.prev = 2;
          return _context6.delegateYield(_regenerator2.default.mark(function _callee4() {
            var env, command, config, steps, modules, hasErrors, allFiles;
            return _regenerator2.default.wrap(function _callee4$(_context5) {
              while (1) {
                switch (_context5.prev = _context5.next) {
                  case 0:
                    env = _yargs2.default.argv.env || 'dev';
                    command = _yargs2.default.argv._[0];
                    config = (0, _index.load)('gassetic.yml');

                    (0, _index.validate)(config);

                    steps = getBuildSteps(config);
                    modules = loadModules(config.requires);

                    // clear

                    _context5.next = 8;
                    return _promise2.default.all(steps.reduce(function (promises, deps) {
                      return promises.concat(deps.reduce(function (currentMimetypePromises, dep) {
                        return currentMimetypePromises.concat((0, _keys2.default)(config.mimetypes[dep].files || {}).map(function (destinationFolder) {
                          return _path2.default.join(config.mimetypes[dep][env].outputFolder, destinationFolder);
                        }));
                      }, []));
                    }, []).map(function (destinationFolder) {
                      return (0, _del2.default)(destinationFolder);
                    }));

                  case 8:
                    if (!(command === 'clear')) {
                      _context5.next = 11;
                      break;
                    }

                    _gulpUtil2.default.log(_gulpUtil2.default.colors.green('Cleared.'));
                    return _context5.abrupt('return', {
                      v: void 0
                    });

                  case 11:
                    if (!(steps.length == 0)) {
                      _context5.next = 13;
                      break;
                    }

                    return _context5.abrupt('return', {
                      v: void 0
                    });

                  case 13:
                    hasErrors = false;
                    _context5.next = 16;
                    return _promise2.default.all(steps.map(function () {
                      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(deps) {
                        var replacements, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _loop, _iterator, _step;

                        return _regenerator2.default.wrap(function _callee3$(_context4) {
                          while (1) {
                            switch (_context4.prev = _context4.next) {
                              case 0:
                                replacements = [];
                                _iteratorNormalCompletion = true;
                                _didIteratorError = false;
                                _iteratorError = undefined;
                                _context4.prev = 4;
                                _loop = _regenerator2.default.mark(function _loop() {
                                  var dep;
                                  return _regenerator2.default.wrap(function _loop$(_context3) {
                                    while (1) {
                                      switch (_context3.prev = _context3.next) {
                                        case 0:
                                          dep = _step.value;
                                          _context3.prev = 1;
                                          return _context3.delegateYield(_regenerator2.default.mark(function _callee2() {
                                            var tasks, startTaskTime, files;
                                            return _regenerator2.default.wrap(function _callee2$(_context2) {
                                              while (1) {
                                                switch (_context2.prev = _context2.next) {
                                                  case 0:
                                                    tasks = getTasks(modules, config.mimetypes[dep], env);
                                                    startTaskTime = new Date();


                                                    _gulpUtil2.default.log(_gulpUtil2.default.colors.magenta('▸') + ' compiling ' + _gulpUtil2.default.colors.cyan(dep) + ' with ' + _gulpUtil2.default.colors.gray(tasks.map(function (t) {
                                                      return t.name;
                                                    }).join(', ')));
                                                    _context2.next = 5;
                                                    return runTasks(config.mimetypes[dep].files, tasks, config.mimetypes[dep][env]);

                                                  case 5:
                                                    files = _context2.sent;

                                                    _gulpUtil2.default.log(_gulpUtil2.default.colors.green('✓') + ' ' + _gulpUtil2.default.colors.green(dep) + ' finished ' + _gulpUtil2.default.colors.gray('in ' + Math.round((new Date() - startTaskTime) / 10) / 100 + 's'));
                                                    replacements.push({
                                                      mimetype: dep,
                                                      htmlTag: config.mimetypes[dep][env].htmlTag || getDefaultHtmlTag((0, _keys2.default)(files)[0] || ''),
                                                      files: files
                                                    });

                                                    if (env === 'dev' && command !== 'build') {
                                                      (0, _entries2.default)(config.mimetypes[dep].files).map(function (_ref3) {
                                                        var _ref4 = (0, _slicedToArray3.default)(_ref3, 2),
                                                            key = _ref4[0],
                                                            files = _ref4[1];

                                                        _gulpUtil2.default.log(_gulpUtil2.default.colors.white('▸ watching') + ' ' + _gulpUtil2.default.colors.gray(key));
                                                        _gulp2.default.watch(config.mimetypes[dep].watch || files, { maxListeners: Infinity }, (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
                                                          return _regenerator2.default.wrap(function _callee$(_context) {
                                                            while (1) {
                                                              switch (_context.prev = _context.next) {
                                                                case 0:
                                                                  _gulpUtil2.default.log(_gulpUtil2.default.colors.yellow('▸ compiling') + ' ' + _gulpUtil2.default.colors.cyan(dep));
                                                                  _context.next = 3;
                                                                  return runTasks((0, _defineProperty3.default)({}, key, files), tasks, config.mimetypes[dep][env]);

                                                                case 3:
                                                                  _gulpUtil2.default.log(_gulpUtil2.default.colors.green('✓') + ' finished ' + _gulpUtil2.default.colors.cyan(dep));

                                                                case 4:
                                                                case 'end':
                                                                  return _context.stop();
                                                              }
                                                            }
                                                          }, _callee, undefined);
                                                        })));
                                                      });
                                                    }

                                                  case 9:
                                                  case 'end':
                                                    return _context2.stop();
                                                }
                                              }
                                            }, _callee2, undefined);
                                          })(), 't0', 3);

                                        case 3:
                                          _context3.next = 9;
                                          break;

                                        case 5:
                                          _context3.prev = 5;
                                          _context3.t1 = _context3['catch'](1);

                                          hasErrors = true;
                                          _gulpUtil2.default.log(_gulpUtil2.default.colors.red(_context3.t1));

                                        case 9:
                                        case 'end':
                                          return _context3.stop();
                                      }
                                    }
                                  }, _loop, undefined, [[1, 5]]);
                                });
                                _iterator = (0, _getIterator3.default)(deps);

                              case 7:
                                if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                                  _context4.next = 12;
                                  break;
                                }

                                return _context4.delegateYield(_loop(), 't0', 9);

                              case 9:
                                _iteratorNormalCompletion = true;
                                _context4.next = 7;
                                break;

                              case 12:
                                _context4.next = 18;
                                break;

                              case 14:
                                _context4.prev = 14;
                                _context4.t1 = _context4['catch'](4);
                                _didIteratorError = true;
                                _iteratorError = _context4.t1;

                              case 18:
                                _context4.prev = 18;
                                _context4.prev = 19;

                                if (!_iteratorNormalCompletion && _iterator.return) {
                                  _iterator.return();
                                }

                              case 21:
                                _context4.prev = 21;

                                if (!_didIteratorError) {
                                  _context4.next = 24;
                                  break;
                                }

                                throw _iteratorError;

                              case 24:
                                return _context4.finish(21);

                              case 25:
                                return _context4.finish(18);

                              case 26:
                                return _context4.abrupt('return', replacements);

                              case 27:
                              case 'end':
                                return _context4.stop();
                            }
                          }
                        }, _callee3, undefined, [[4, 14, 18, 26], [19,, 21, 25]]);
                      }));

                      return function (_x) {
                        return _ref2.apply(this, arguments);
                      };
                    }()));

                  case 16:
                    _context5.t0 = function (a, b) {
                      return a.concat(b);
                    };

                    _context5.t1 = function (a) {
                      return a.htmlTag;
                    };

                    allFiles = _context5.sent.reduce(_context5.t0).filter(_context5.t1);


                    _gulpUtil2.default.log(_gulpUtil2.default.colors.blue('Updating templates 📝'));
                    _context5.next = 22;
                    return replaceInTemplates(config.replacementPaths, allFiles, env);

                  case 22:
                    _gulpUtil2.default.log(_gulpUtil2.default.colors.blue('Creating gassetic.dump.' + env + '.yml'));
                    _context5.next = 25;
                    return createResultsFile(config.resultsFolder, allFiles, env);

                  case 25:
                    _gulpUtil2.default.log(_gulpUtil2.default.colors.green('Build finished in ' + Math.round((new Date() - startTime) / 10) / 100 + 's \uD83D\uDC4D'));
                    if (hasErrors) {
                      _gulpUtil2.default.log(_gulpUtil2.default.colors.red('But hey, there were errors'));
                      process.exit(1);
                    } else if (env !== 'dev' || command === 'build') {
                      process.exit(0);
                    }

                  case 27:
                  case 'end':
                    return _context5.stop();
                }
              }
            }, _callee4, undefined);
          })(), 't0', 4);

        case 4:
          _ret = _context6.t0;

          if (!((typeof _ret === 'undefined' ? 'undefined' : (0, _typeof3.default)(_ret)) === "object")) {
            _context6.next = 7;
            break;
          }

          return _context6.abrupt('return', _ret.v);

        case 7:
          _context6.next = 13;
          break;

        case 9:
          _context6.prev = 9;
          _context6.t1 = _context6['catch'](2);

          _gulpUtil2.default.log(_gulpUtil2.default.colors.red(_context6.t1, _context6.t1.stack));
          process.exit(1);

        case 13:
        case 'end':
          return _context6.stop();
      }
    }
  }, _callee5, undefined, [[2, 9]]);
}));

// steps

var getBuildSteps = exports.getBuildSteps = function getBuildSteps(config) {
  return config.default.map(function (mimetype) {
    return getBuildStepDependency(config, mimetype);
  });
};

var getBuildStepDependency = function getBuildStepDependency(config, mimetype) {
  return (config.mimetypes[mimetype].deps || []).reduce(function (final, dep) {
    return getBuildStepDependency(config, dep).concat(final);
  }, [mimetype]);
};

// modules
var loadModules = function loadModules(requires) {
  module.paths.unshift(_path2.default.join(process.cwd(), 'node_modules'));
  module.paths.unshift(process.cwd());
  return (0, _entries2.default)(requires).reduce(function (registry, _ref6) {
    var _ref7 = (0, _slicedToArray3.default)(_ref6, 2),
        moduleKey = _ref7[0],
        module = _ref7[1];

    return (0, _extends4.default)({}, registry, (0, _defineProperty3.default)({}, moduleKey, require(module.startsWith('./') && _path2.default.join(process.cwd(), module) || module)));
  }, {});
};

// tasks
var getTasks = exports.getTasks = function getTasks(modules, mimetype, environment) {
  return mimetype[environment].tasks.reduce(function (tasks, task) {
    if (task.callback) {
      task.callback = modules[task.callback];
    }
    var taskDescription = (0, _extends4.default)({}, task, { fn: getModuleFunction(modules, task.name) });
    if (task.filter) {
      var filter = (0, _gulpFilter2.default)(task.filter, { restore: true });
      return [].concat((0, _toConsumableArray3.default)(tasks), [(0, _extends4.default)({}, taskDescription, { filter: filter })]);
    }
    return [].concat((0, _toConsumableArray3.default)(tasks), [taskDescription]);
  }, []);
};

var getModuleFunction = function getModuleFunction(modules, taskName) {
  return taskName.split('.').reduce(function (scope, taskPart) {
    return scope[taskPart];
  }, modules);
};

var runTasks = exports.runTasks = function () {
  var _ref8 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(files, tasks, _ref9) {
    var outputFolder = _ref9.outputFolder,
        webPath = _ref9.webPath;
    return _regenerator2.default.wrap(function _callee6$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            _context7.next = 2;
            return _promise2.default.all((0, _keys2.default)(files).map(function (destFilename) {
              return new _promise2.default(function (resolve, reject) {
                try {
                  (function () {
                    var filesCreated = [];
                    [{ fn: _gulpPlumber2.default, callback: function callback(e) {
                        return reject(e);
                      } }].concat(tasks).reduce(function (pipe, nextTask) {
                      if (nextTask.filter) {
                        pipe = pipe.pipe(nextTask.filter);
                      }
                      pipe = pipe.pipe(nextTask.callback ? nextTask.fn(nextTask.callback) : replaceArguments(nextTask, { filename: destFilename })());
                      if (nextTask.filter) {
                        pipe = pipe.pipe(nextTask.filter.restore);
                      }
                      return pipe;
                    }, _gulp2.default.src(files[destFilename])).pipe(_gulp2.default.dest(_path2.default.join(outputFolder, destFilename))).pipe((0, _gulpTap2.default)(function (file) {
                      if (_yargs2.default.argv.print) _gulpUtil2.default.log(_gulpUtil2.default.colors.white('▸ ') + _gulpUtil2.default.colors.gray('compiled ' + file.path));

                      if (!webPath) return;
                      var filepath = file.path.substring(process.cwd().length).replace(/\\/g, '/').replace(outputFolder, '');
                      var fileWebPath = _path2.default.join(webPath, filepath).replace(/\\/g, '/');
                      filesCreated.push(fileWebPath);
                    })).on('end', function () {
                      return resolve((0, _defineProperty3.default)({}, destFilename, filesCreated));
                    });
                  })();
                } catch (e) {
                  reject(e);
                }
              });
            }));

          case 2:
            _context7.t0 = function (all, next) {
              return (0, _extends4.default)({}, all, next);
            };

            _context7.t1 = {};
            return _context7.abrupt('return', _context7.sent.reduce(_context7.t0, _context7.t1));

          case 5:
          case 'end':
            return _context7.stop();
        }
      }
    }, _callee6, undefined);
  }));

  return function runTasks(_x2, _x3, _x4) {
    return _ref8.apply(this, arguments);
  };
}();

var replaceArguments = function replaceArguments(_ref10, _ref11) {
  var fn = _ref10.fn,
      args = _ref10.args;
  var filename = _ref11.filename;
  return function () {
    var replaced = JSON.parse((0, _stringify2.default)(args || []).replace('%filename%', filename));
    return fn.apply(fn, Array.isArray(replaced) && replaced || [replaced]);
  };
};

// replacement paths
var replaceInTemplates = exports.replaceInTemplates = function replaceInTemplates(replacementPaths, files, environment) {
  return new _promise2.default(function () {
    var _ref12 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7(resolve, reject) {
      var templates;
      return _regenerator2.default.wrap(function _callee7$(_context8) {
        while (1) {
          switch (_context8.prev = _context8.next) {
            case 0:
              _context8.prev = 0;
              _context8.next = 3;
              return _promise2.default.all(replacementPaths.map(globPromised));

            case 3:
              _context8.t0 = function (a, b) {
                return a.concat(b);
              };

              templates = _context8.sent.reduce(_context8.t0);

              templates.forEach(function (template) {
                var content = files.reduce(function (newContent, mimetype) {
                  return (0, _entries2.default)(mimetype.files).reduce(function (newContent, _ref13) {
                    var _ref14 = (0, _slicedToArray3.default)(_ref13, 2),
                        destFilename = _ref14[0],
                        files = _ref14[1];

                    var scripts = files.map(function (path) {
                      return (mimetype.htmlTag || getDefaultHtmlTag(path)).replace('%path%', path);
                    });
                    return newContent.replace(new RegExp('([ \t]*)<!-- ' + environment + ':' + destFilename + ' -->([\\s\\S]*?)<!-- endbuild -->', 'ig'), '$1<!-- ' + environment + ':' + destFilename + ' -->\n$1' + scripts.map(function (script) {
                      return '  ' + script;
                    }).join('\n$1') + '\n$1<!-- endbuild -->');
                  }, newContent);
                }, _fs2.default.readFileSync(template, 'utf-8'));
                _fs2.default.writeFileSync(template, content);
              });
              resolve();
              _context8.next = 12;
              break;

            case 9:
              _context8.prev = 9;
              _context8.t1 = _context8['catch'](0);

              reject(_context8.t1);

            case 12:
            case 'end':
              return _context8.stop();
          }
        }
      }, _callee7, undefined, [[0, 9]]);
    }));

    return function (_x5, _x6) {
      return _ref12.apply(this, arguments);
    };
  }());
};

var getDefaultHtmlTag = function getDefaultHtmlTag(filename) {
  return {
    '.js': '<script src="%path%"></script>',
    '.css': '<link rel="stylesheet" type="text/css" href="%path%">'
  }[_path2.default.extname(filename)] || '<!-- htmlTag not provided -->';
};

var createResultsFile = function createResultsFile() {
  var resultsFolder = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : process.cwd();
  var files = arguments[1];
  var environment = arguments[2];
  return new _promise2.default(function (resolve) {
    var dump = _jsYaml2.default.safeDump(files, { lineWidth: Infinity });
    _fs2.default.writeFileSync(_path2.default.join(resultsFolder, 'gassetic.dump.' + environment + '.yml'), dump, 'utf-8');
    resolve();
  });
};

var globPromised = function globPromised(pattern) {
  return new _promise2.default(function (resolve) {
    return (0, _glob2.default)(pattern, {}, function (err, matches) {
      return resolve(matches);
    });
  });
};